#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstring>
#include <ctime>
#include <cmath>
#include <cstdlib>
using namespace std ;

#include "code.h"
#include "decode.h"

const int MAXL = 10000 ;

int n , k , d , q ;
int T ;
int A[MAXL+1] , B[MAXL+1] ;

void Interference(int r , int e) { // B[]
    srand(time(NULL)) ;
    for ( int i = 1 ; i <= e ; i ++ ) {
        int v = rand() % r + 1 ;
        int u = rand() % q ;
        B[v] = u ;
    }
}

ifstream fin("code.in") ;
ofstream fout("code.out") ;

int main() {
    fin >> k >> d >> q ;
    fin >> T ;
    for ( int i = 1 ; i <= T ; i ++ ) {
        for ( int j = 1 ; j <= k ; j ++ ) fin >> A[j] ; for ( int j = k+1 ; j <= MAXL ; j ++ ) A[j] = rand() ;
        for ( int j = 1 ; j <= k ; j ++ ) B[j] = A[j] ;
        n = Alice_solve(k,d,q,B) ;                      for ( int j = n+1 ; j <= MAXL ; j ++ ) B[j] = rand() ;
        if ( n > 8000 ) {
            fout << "NO\n" ;
            continue ;
        }
        Interference(n , (int)((d-1)/2)) ;
        Bob_solve(k,d,q,B) ;                            for ( int j = k+1 ; j <= MAXL ; j ++ ) B[j] = rand() ;
        int tmp = 0 ;
        for ( int j = 1 ; j <= k ; j ++ )
            if ( A[j] != B[j] ) tmp = 1 ;
        if ( tmp == 1 ) fout << "NO\n" ;
        else            fout << "YES " << n << "\n" ;
    }
}
