uses code, decode;

const MAXL = 10010;
var
	n, k, d, q, i, j, tmp : longint;
	T : longint;
	A, B : array[0..MAXL] of longint;
	
procedure Interference(r, e : longint);
var
	i, v, u : longint;
begin
	randomize;
	for i := 1 to e do
	begin
		v := random(r) + 1;
		u := random(q);
		B[v] := u;
	end;
end;

begin
	assign(input, 'code.in');
	reset(input);
	assign(output, 'code.out');
	rewrite(output);
	readln(k, d, q);
	readln(t);
	for i := 1 to T do
	begin
		for j := 1 to k do
			read(A[j]);
		for j := k + 1 to MAXL do
			A[j] := random(32767);
		for j := 1 to k do
			B[j] := A[j];
		n := Alice_solve(k, d, q, B);
		for j := n + 1 to MAXL do
			B[j] := random(32767);
		if (n > 8000) then begin
		    writeln('NO');
		    continue ;
		end;
		Interference(n, (d-1) div 2);
		Bob_solve(k, d, q, B);
		for j := k + 1 to MAXL do
			B[j] := random(32767);
		tmp := 0;
		for j := 1 to k do
			if (A[j] <> B[j]) then tmp := 1;
		if (tmp = 1) then writeln('NO')
		else writeln('YES', n);
	end;
	close(input);
	close(output);
end.
